// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	BulletinBoard.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Mon May  8 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_BulletinBoard_h
#define _SCPP_BulletinBoard_h

#include <scxx.h>
#include <GUI.h>
#include <GWindow.h>

class PBulletinBoard;
/*
   Bulletinboard is the most basic of Container objects.
   Contained objects are pinned up on the BulletinBoard
   in a particular location and remains there.
*/
active class BulletinBoard : public GWindow {

public:
  
  BulletinBoard(GUI &gui, const char* title, 
		int x=-1, int y=-1, 
		const char *objectName="BulletinBoard",
		ArgList userOptions=0, Cardinal nUserOptions=0, 
		Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  BulletinBoard(GWindow &W, 
		const char*objectName="BulletinBoard", 
		ArgList userOptions=0, Cardinal nUserOptions=0, 
		Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  BulletinBoard(BulletinBoard &W, 
		const char*objectName="BulletinBoard", 
		ArgList userOptions=0, Cardinal nUserOptions=0, 
		Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Motif Resources :
  void Resources(Boolean allowOverlap=GUIBool::GUI_TRUE,
		 Boolean autoUnmanage=GUIBool::GUI_TRUE,
		 XmFontList buttonFontList=XmFontList(-1),
		 Boolean defaultPosition=GUIBool::GUI_TRUE,
		 GUIDialogStyle::Value dialogStyle=GUIDialogStyle::DEFAULT,
		 const char *dialogTitle=0,
		 XmFontList labelFontList=XmFontList(-1),
		 int  marginHeight=-1,
		 int  marginWidth=-1,
		 Boolean noResize=GUIBool::GUI_FALSE,
		 GUIResizePolicy::Value resizePolicy=GUIResizePolicy::DEFAULT,
		 GUIShadowType::Value shadowType=GUIShadowType::DEFAULT,
		 XmFontList textFontList=XmFontList(-1));
		
  PBulletinBoard *Passive();

  ~BulletinBoard();

  private :
  PBulletinBoard *impl;
};

#endif /* _SCPP_BulletinBoard_h */






