// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	CheckBox.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_CheckBox_h
#define _SCPP_CheckBox_h

#include <scxx.h>
#include <GWindow.h>
#include <SimpleButtonContainer.h>

class PCheckBox;

/*
 A CheckBox is similar to a RadioBox. except that there is no restriction
 on how many items may be selected at once.
 A CheckBox is only composed of ToggleButtons.
*/

active class CheckBox : public SimpleButtonContainer {

 public:

  // sequential : 
  //   If set to True it enforces sequential behavior of events :
  //      Application must always accept related events to this object in order
  //      to receive the next GUI event (avoid deadlocks with other possible GUI events)
  //   By default reception in order of GUI events is not provided allowing application
  //      to synchronize with GUI objects on demand
  //

  CheckBox(GWindow &W, 
	   GUIOrientation::Value orientation=GUIOrientation::VERTICAL,
	   const char* name="CheckBox", 
	   ArgList userOptions=0, Cardinal nUserOptions=0, 
	   Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  CheckBox(GWindow &W, int numRowColumn,
	   GUIOrientation::Value orientation=GUIOrientation::VERTICAL,
	   const char* name="CheckBox", 
	   ArgList userOptions=0, Cardinal nUserOptions=0, 
	   Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Motif Resources :
  void Resources(Boolean adjustLast=GUIBool::DEFAULT,
		 Boolean adjustMargin=GUIBool::DEFAULT,
		 GUIAlignment::Value entryAlignment=GUIAlignment::DEFAULT,
		 int entryBorder=-1,
		 GUIVerticalAlignment::Value entryVerticalAlignment=
		 GUIVerticalAlignment::DEFAULT,
		 Boolean isAligned=GUIBool::DEFAULT,
		 int marginHeight=-1,
		 int marginWidth=-1,
		 short numColumns=-1,
		 GUIOrientation::Value orientation=GUIOrientation::DEFAULT,
		 GUIPacking::Value packing=GUIPacking::DEFAULT,
		 Boolean resizeHeight=GUIBool::DEFAULT,
		 Boolean resizeWidth=GUIBool::DEFAULT,
		 int spacing=-1);

  ~CheckBox();

  PCheckBox *Passive();

  private :
  
  PCheckBox *impl;
};

extern PCheckBox &MyGPassive(CheckBox &g);

#endif /* _SCPP_CheckBox_h */
