// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	Form.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Mon May  8 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_Form_h
#define _SCPP_Form_h

#include <scxx.h>
#include <GUI.h>
#include <GWindow.h>

class PForm;

/*
   Container object that implements a sophisticated geometry management policy
   that involves both absolute and relative positioning and sizing of its children
   For example, a Form may lay out its children in a grid-like manner, anchoring (attaching)
   the edges of each child to specific positions on the grid, or it may attach the children
   to one another in a chain-like fashion.
   
   Attachements are implemented by methods in GWidget class inherited by all possible
   children of a Form container.
   For more details see Attachment examples and documentation
*/
active class Form : public GWindow {
public:
  Form(GUI &gui, const char* title, int x=1, int y=1, 
       const char *objectName="Form",
       ArgList userOptions=0, Cardinal nUserOptions=0,
       Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  Form(GWindow &W, const char* objectName="Form", 
       ArgList userOptions=0, Cardinal nUserOptions=0, 
       Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Default copy constructor don't create that it's necessary at 
  // implementation  level. 
  Form(Form &F, const char* objectName="Form", 
       ArgList userOptions=0, Cardinal nUserOptions=0, 
       Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Motif resources :

  void Resources(int fractionBase=-1,
		 int horizontalSpacing=-1,
		 Boolean rubberPositioning=GUIBool::GUI_FALSE,
		 int verticalSpacing=-1);
       
  PForm *Passive();
       
  ~Form();

  private :

  PForm *impl;
};

#endif /* _SCPP_Form_h */






