// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: GUI.h,v 1.1 1995/10/28 15:29:10 pineda Exp pineda $
// 
// Contens:	GUI.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Mon May  8 1995
//
// $Author: pineda $
// $Date: 1995/10/28 15:29:10 $
// $Revision: 1.1 $
// $State: Exp $
// $Header: /users/pineda/scpp/src/GUI/RCS/GUI.h,v 1.1 1995/10/28 15:29:10 pineda Exp pineda $
// $Locker: pineda $
// $Log: GUI.h,v $
// Revision 1.1  1995/10/28 15:29:10  pineda
// Initial revision
//

#ifndef _SCPP_GUI_h
#define _SCPP_GUI_h

#include <scxx.h>
#include <GUIGlobal.h>
#include <GUIMirrorTypes.h>

class PGUI;

/*
   This object initialize the GUI window system.
   Resources such display, colors, ... can be passed by the program to the GUI
   object.
   Usually, only one object of that type needs to be created in order to 
   create the main application window, but if necessary different sets of 
   resources can be associated to different application windows.
   For example multiple GUI objects can be created in order to display windows
   on different machines.
*/

active class GUI {

public:

  // simplest constructor, no resources specified.
  GUI(int debug=0);

  // Pass the command arguments to window system.
  GUI(int &argc, char* argv[], int debug = 0);

  // This constructor stop the program.
  // Don't copy a GUI object : Instead use a reference.
  GUI(const GUI &gui);

  ~GUI();

  // for X specialists.
  GUI(int &argc, char* argv[], 
      String appClass, 
      XrmOptionDescList options=(XrmOptionDescList)0, int numOptions=0,
      String *fallbackResources=(String *)0,
      ArgList args=0, int numArgs=0, int debug = 0);

  // None of the methods have to be used by programmers
  // All methods are only for internal purpose and extension of the GUI library
  // They are intended for programmers of new GUI library's elements.

  // used mainly in tests and depuration.
  void Flush();
  void Sync(Boolean discar = False);
  void Synchronize(Boolean onoff = True);

  // used in windows creation.
  Widget &AppShell() ;         // used by container windows.
  XtAppContext &AppContext() ; // used by container windows.

  // return a pointer on passive component.
  // used in passive classes construction.
  PGUI *Passive();

private:
  PGUI *impl;
  @GUI();
};

extern PGUI &MyGPassive(GUI &g);

#endif /* _SCPP_GUI_h */
