// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	GUIMouse.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Fri Apr 26 1996
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef __GUIMouse__H__
#define __GUIMouse__H__

#include <scxx.h>
#include <DrawingArea.h>

#define MOUSEBUTTON 3

typedef XEvent GUIEvent;

class GUIMouseImpl;

active class GUIMouse {

  protected :

  GUIMouseImpl *impl;
  int pressedOn[MOUSEBUTTON];
  int releasedOn[MOUSEBUTTON];

  public :

  // User actions with mouse on this graphical window will be
  // comunicated to program.

  GUIMouse(DrawingArea &gw,
	   Boolean sensitive=GUIBool::SENSITIVE);
  ~GUIMouse();

  // this methods comunicates the user action of click in the graphical
  // window. Return values are the logical coordinates of the click.


  void Pressed1(int &x,int &y);
  void Pressed2(int &x,int &y);
  void Pressed3(int &x,int &y);

  void Released1(int &x,int &y);
  void Released2(int &x,int &y);
  void Released3(int &x,int &y);

  void Moved(int &x,int &y);

  void Pressed1(GUIEvent* &event,int &x,int &y);
  void Pressed2(GUIEvent* &event,int &x,int &y);
  void Pressed3(GUIEvent* &event,int &x,int &y);

  void Released1(GUIEvent* &event,int &x,int &y);
  void Released2(GUIEvent* &event,int &x,int &y);
  void Released3(GUIEvent* &event,int &x,int &y);

  void Moved(GUIEvent* &event,int &x,int &y);

  void PressedEvent(unsigned int button);
  void ReleasedEvent(unsigned int button);
  void MovedEvent(void);

  // (Ignores/accepts) Enable/disable comunication of user actions.
  // "reset" Parameter indicates if already internally accept user actions
  // must be dircarded.

  void Sensitive(Boolean sensitive, Boolean reset=GUIBool::NO_RESET);

  // Returns sensitive (enabled/disabled) state of GUIMouse.
  Boolean Sensitive() const;
  GUIMouseImpl *Implementation() const;

  private :

  @GUIMouse();
};

#endif
