// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	Label.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_Label_h
#define _SCPP_Label_h

#include <scxx.h>
#include <GUIMirrorTypes.h>
#include <GWidget.h>
#include <GWindow.h>
#include <CharString.h>

class PLabel;

/*
 Display a string of characters.
 Multi line strings are supported.
 Multi font display is not supported (use two Labels objects).
*/

active class Label : public GWidget {

public:
  Label(GWindow &W, const CharString &str,
	GUIAlignment::Value alignment=GUIAlignment::DEFAULT, 
	const char *objectName=0,
	ArgList userOptions=0, Cardinal nUserOptions=0,
	Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Change the label's content.
  void Write(const CharString &newLabel);
  void Write(const char* newLabel);

  ~Label();

  PLabel * Passive();

  private :
  PLabel *impl;
};

#endif /* _SCPP_Label_h */

