// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	LabelPixmap.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_LabelPixmap_h
#define _SCPP_LabelPixmap_h

#include <scxx.h>
#include <GWindow.h>
#include <CharString.h>
#include <GUIMirrorTypes.h>

class PLabelPixmap;

/*
 LabelPixmap is like a Label except that it displays graphical information.
*/

class LabelPixmap {

public:

  // pixmapName : File name containing the X bitmap to be displayed.

  LabelPixmap(GWindow &W, const CharString &pixmapName, 
	      const CharString &insensitivePixmapName, 
	      GUIAlignment::Value alignment=GUIAlignment::DEFAULT, 
	      const char *foregroundColorName=0,
	      const char *backgroundColorName=0,
	      const char *objectName="LabelPixmap",
	      ArgList userOptions=0, Cardinal nUserOptions=0,
	      Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);
  
  // Motif resources :
  void Resources(Pixmap labelPixmap=Pixmap(-1),
		 Pixmap labelInsensitivePixmap=Pixmap(-1),
		 int marginBottom=-1,
		 int marginHeight=-1,
		 int marginLeft=-1,
		 int marginRight=-1,
		 int marginTop=-1,
		 int marginWidth=-1,
		 Boolean recomputeSize=True);
  
  
  PLabelPixmap *Passive();     

  ~LabelPixmap();

  private :

  PLabelPixmap *impl;     
};


/*
   Implementation notes :
   for Motif users :

   - the widget name is set from "pixmapName" parameter.
     By setting resources in a resource file, 
     it not should have spaces (use "_" character instead).

   Examples of (some) related Motif resources 
   (well defined and general forms ) :
*/

#endif /* _SCPP_LabelPixmap_h */

