// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	MenuBar.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_MenuBar_h
#define _SCPP_MenuBar_h

#include <scxx.h>
#include <GWidget.h>
#include <GWindow.h>
#include <GUIMirrorTypes.h>

class PMenuBar;

/*
 MenuBar is used for constructing a pulldown menu system.
 PulldownMenus are added to MenuBar.
*/

active class MenuBar : public GWidget {
  
public:

  MenuBar(GWindow &W, const char *menuAccelerator=0, 
	  const char *name="MenuBar", 
	  ArgList userOptions=0, Cardinal nUserOptions=0,
	  Boolean sequential=False, int debug=0);

  // Motif Resources (from RowColumn) :
  void Resources(const char *menuAccelerator=0,
		 Boolean adjustLast=GUIBool::DEFAULT,
		 Boolean adjustMargin=GUIBool::DEFAULT,
		 GUIAlignment::Value entryAlignment=GUIAlignment::DEFAULT,
		 int entryBorder=-1,
		 GUIVerticalAlignment::Value entryVerticalAlignment=
		 GUIVerticalAlignment::DEFAULT,
		 Boolean isAligned=GUIBool::DEFAULT,
		 int marginHeight=-1,
		 int marginWidth=-1,
		 Boolean resizeHeight=GUIBool::DEFAULT,
		 Boolean resizeWidth=GUIBool::DEFAULT,
		 int spacing=-1);

  PMenuBar *Passive();
  
  ~MenuBar();

  private :
  PMenuBar *impl;
};

extern PMenuBar &MyGPassive(MenuBar &g);

#endif /* _SCPP_MenuBar_h */

