// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	MenuButton.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_MenuButton_h
#define _SCPP_MenuButton_h

#include <scxx.h>
#include <GUIMirrorTypes.h>
#include <GWidget.h>
#include <Menu.h>

class PMenuButton;

/*
 MenuButton is used as component of any subtype of class Menu or SimpleButtonContainer
 (menu containers).
 An integer code is specified to each MenuButton, the menu container returns this code
 when a MenuButton is selected.
 Each button must have a code unique in a particular menu container.
*/

class MenuButton {

public:

  MenuButton(Menu &M, int code, 
	     const char* str, 
	     char mnemonic='\0', 
	     const char *accelerator=0, const char *acceleratorText=0,
	     const char *internalObjectName=0,
	     ArgList userOptions=0, Cardinal nUserOptions=0);
  
  ~MenuButton();

  
  // Turn sensitive/insensitive the objet.
  //
  void Sensitive(Boolean sensitive=GUIBool::SENSITIVE);
  

  // Motif Resources :
  void Resources(Pixel armColor=Pixel(-1),
		 int defaultButtonShadowThickness=-1,
		 Boolean fillOnArm=GUIBool::DEFAULT,
		 const char *accelerator=0,            // ex. "Ctrl<Key>Q"
		 const char *acceleratorText=0,        // ex. "Ctrl+Q"
		 GUIAlignment::Value alignment=GUIAlignment::DEFAULT,
		 XmFontList fontList=XmFontList(-1),
		 const char *labelString=0,
		 int marginBottom=-1,
		 int marginHeight=-1,
		 int marginLeft=-1,
		 int marginRight=-1,
		 int marginTop=-1,
		 int marginWidth=-1,
		 char mnemonic='\0',
		 const char *mnemonicCharSet=0,
		 Boolean recomputeSize=GUIBool::DEFAULT);

  PMenuButton *Passive();

  private :
  
  PMenuButton *impl;
};

#endif /* _SCPP_MenuButton_h */






