// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	MultipleSelectionList.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue Jun 20 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _MULTIPLE_SELECTION_LIST_H
#define _MULTIPLE_SELECTION_LIST_H

#include <scxx.h>
#include <GWindow.h>
#include <GUIList.h>
#include <ListTemplate.h>
#include <CharString.h>
#include <GUIMirrorTypes.h>

class PMultipleSelectionList;

active class MultipleSelectionList : public GUIList {
 public:

  // height of object is determinated by (priority order) :
  //   container's settings.
  //   itemsCount (-1 is intended for Motif's default).
  //   height     (-1 is intended for Motif's default).
  //   vertical scrollbar is set if needed.
  
  // width of object is determinated by (priority order) :
  //   container's settings.
  //   width      (-1 is intended for Motif's default).
  //   horizontal scrollbar is set if needed.

  MultipleSelectionList(GWindow &W, 
			short visibleItemsCount=-1,
			int numCharWidth=-1,
			ListTemplate<CharString> &items=
			ListTemplate<CharString>(),
			GUIListSelectionPolicy::Value selectionPolicy=
			GUIListSelectionPolicy::EXTENDED_SELECT,
			GUIListSizePolicy::Value listSizePolicy=
			GUIListSizePolicy::DEFAULT,
			const char *objectName="MultipleSelectionList", 
			ArgList userOptions=0, Cardinal nUserOptions=0,
			Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug = 0);

  // Return selected items and/or positions.
  // this functions don't wait a synchronization.
  // positions start in 0. If there isn't a selection, position will be XXX
  void  GetCurrentSelection(ListTemplate<int> &positions); // select. positions
  void  GetCurrentSelection(ListTemplate<CharString> &items);// selected items.
  void  GetCurrentSelection(ListTemplate<CharString> &items,
			    ListTemplate<int> &positions);

  ~MultipleSelectionList();
  
  PMultipleSelectionList *Passive();

  protected :
  
  PMultipleSelectionList *impl;
};

#endif //_MULTIPLE_SELECTION_LIST_H
