// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	OptionMenu.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_OptionMenu_h
#define _SCPP_OptionMenu_h

#include <scxx.h>
#include <GUIMirrorTypes.h>
#include <Menu.h>
#include <GWindow.h>
#include <MenuButton.h>

class POptionMenu;

/*
 An OptionMenu is typically used to promt the user to choose a value.
 It displays a Label and a menu button that shows the current value.
 When the user clicks on the button, a menu that contains the rest of the choices
 is popped up directly on top of the button. Choosing an item from the menu modifies
 the menu button title so that it shows the currently-selected item.
 An OptionMenu is can contain MenuButtons, ToggleButtons or other PullDownMenus.
*/

class MenuButton;

active class OptionMenu : public Menu {

public:

  // sequential : 
  //   If set to True it enforces sequential behavior of events :
  //      Application must always accept related events to this object in order
  //      to receive the next GUI event (avoid deadlocks with other possible GUI events)
  //   By default reception in order of GUI events is not provided allowing application
  //      to synchronize with GUI objects on demand

  OptionMenu(GWindow &W, const char *labelString=0,
	     char mnemonic='\0', const char* name="OptionMenu", 
	     ArgList userOptions=0, Cardinal nUserOptions=0, 
	     Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Set Option to display :
  // parameter :
  // button : should be a child of calling OptionMenu.
  void SetCurrentOption(MenuButton &button);

  // Return current option.
  int GetCurrentOption() const;

  // Turn sensitive/insensitive the objet.
  //
  void Sensitive(Boolean sensitive_on=GUIBool::SENSITIVE);

  // fontName example : "-Adobe-Times-Medium-I-Normal--10*"
  //
  void SetFont(const char *fontName);

  // Motif's resources :
  void Resources(const char *labelString=0, char mnemonic='\0');
       
  // Widget &WidgetToAttach();

  POptionMenu *Passive();
 
  ~OptionMenu();

  private :
  
  POptionMenu *impl;
};

#endif /* _SCPP_OptionMenu_h */
