// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	PanedWindow.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Mon May  8 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_PanedWindow_h
#define _SCPP_PanedWindow_h

#include <scxx.h>
#include <GUI.h>
#include <GWindow.h>
#include <GUIMirrorTypes.h>

class PPanedWindow;

/*
 The PanedWindow container lays out its children (contained objects) in a vertical-tiled
 format, from top to bottom in the order that they are added to the PanedWindow.
 The idea behind the PanedWindow is that the user can adjust the individual panes
 to provide more or less space as needed per-child basis.
 When the user moves the shash, the object above or below the one being resized
 is resized smaller to compensate for the size change.
 A Child takes its width from the widest of the children.
 PanedWindow also provides control dashes or grips that enables user to adjust
 the individual heights of the PanedWindow's children.
 Each child can specify its desired maximun and minimun height
 and wheter it may be resized or not.
*/

active class PanedWindow : public GWindow {

public:
  
  PanedWindow(GUI &gui, const char* title, int x=-1, int y=-1,
	      Boolean separatorOn=GUIBool::SHOW, 
	      const char *objectName="PanedWindow", 
	      ArgList userOptions=0, Cardinal nUserOptions=0,  
	      Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  PanedWindow(GWindow &W, Boolean separatorOn=GUIBool::SHOW, 
	      const char *objectName="PanedWindow", 
	      ArgList userOptions=0, Cardinal nUserOptions=0, 
	      Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  PanedWindow(PanedWindow &W, Boolean separatorOn=GUIBool::SHOW, 
	      const char *objectName="PanedWindow", 
	      ArgList userOptions=0, Cardinal nUserOptions=0, 
	      Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Motif resources :
  void Resources(int marginHeight=-1,
		 int marginWidth=-1,
		 Boolean refigureMode=True,
		 int sashHeight=-1,
		 int sashIndent=-1,
		 int sashShadowThickness=-1,
		 int sashWidth=-1,
		 Boolean separatorOn=GUIBool::DEFAULT,
		 int spacing=-1);
       
  PPanedWindow *Passive();

  private :

  PPanedWindow *impl;
};

#endif /* _SCPP_PanedWindow_h */






