// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	PopUpMenu.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_PopUpMenu_h
#define _SCPP_PopUpMenu_h

#include <scxx.h>
#include <Menu.h>
#include <GWidget.h>

class PPopUpMenu;

/*
 A PopupMenu is not necessarily attached to a visible interface element.
 Unlike the other types of menus, a PopupMenu can be popped up at any arbitrary location
 in an application, usually as a result of the user pressing the third mouse button.
 PopupMenus are meant to provide shortcuts to application functionality,
 so an application can use different PopupMenus in different contexts and for
 different components in an interface.
 A PopupMenu is can contain MenuButtons, ToggleButtons or other PullDownMenus.
*/

active class PopUpMenu : public Menu {

public:

  // sequential : 
  //   If set to True it enforces sequential behavior of events :
  //      Application must always accept related events to this object in order
  //      to receive the next GUI event (avoid deadlocks with other possible GUI events)
  //   By default reception in order of GUI events is not provided allowing application
  //      to synchronize with GUI objects on demand

  PopUpMenu(GWidget &W, Boolean tearOff=GUIBool::GUI_TRUE,
	    const char* menuAccelerator=0,
	    const char* name="PopUpMenu", 
	    ArgList userOptions=0, Cardinal nUserOptions=0, 
	    Boolean sequential=GUIBool::NO_SEQUENTIAL, int debug=0);

  // Motif Resources :
  void Resources(const char *menuAccelerator=0,
		 Boolean popupEnabled=GUIBool::DEFAULT);

  PPopUpMenu *Passive();

  ~PopUpMenu();

  private :

  @PopUpMenu(); // dummy body.

  PPopUpMenu *impl;
};

extern PPopUpMenu &MyGPassive(PopUpMenu &g);

#endif /* _SCPP_PopUpMenu_h */
