#ifndef _SCPP_PushButtonPixmap_h
#define _SCPP_PushButtonPixmap_h

#include <scxx.h>
#include <GUIMirrorTypes.h>
#include <BasicPushButton.h>
#include <GWindow.h>

class PPushButtonPixmap;

/*
 PushButtonPixmap is like a PushButton except that it displays a Pushbutton
 which content is a graphical information.
 Visual effects are provided when it is pressed and released.
*/

active class PushButtonPixmap : public BasicPushButton {
public:

  // pixmapName : File name containing the X bitmap to be displayed.
  // insensitivePixmapName : File name containing the X bitmap to be displayed
  //                         when PushButtonPixmap is unsensitive. 
  //                         If no parameter is specified, it uses the same file as
  //                         specified by "pixmapName" parameter.

  PushButtonPixmap(GWindow &W, const char* pixmapName, 
		   const char* insensitivePixmapName=0, 
		   const char *objectName="PushButtonPixmap",
		   ArgList wargs=0, Cardinal nUserOptions=0,
		   Boolean sequential=False, int debug = 0);
  
  // Motif Resources :
  void Resources(Pixel armColor=Pixel(-1),
		 Pixmap armPixmap=Pixmap(-1),
		 int defaultButtonShadowThickness=-1,
		 Boolean fillOnArm=GUIBool::DEFAULT,
		 GUIButtonMultiClick::Value multiClick=
		 GUIButtonMultiClick::DEFAULT,
		 int showAsDefault=-1,
		 Pixmap labelPixmap=Pixmap(-1),
		 Pixmap labelInsensitivePixmap=Pixmap(-1),
		 GUIAlignment::Value alignment=GUIAlignment::DEFAULT,
		 int marginBottom=-1,
		 int marginHeight=-1,
		 int marginLeft=-1,
		 int marginRight=-1,
		 int marginTop=-1,
		 int marginWidth=-1,
		 Boolean recomputeSize=GUIBool::DEFAULT);     
		 
  ~PushButtonPixmap();
		 
  PPushButtonPixmap *Passive();
		 
  private :

  PPushButtonPixmap *impl;
};

#endif /* _SCPP_PushButtonPixmap_h */






