// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	Separator.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_Separator_h
#define _SCPP_Separator_h

#include <GUIMirrorTypes.h>
#include <PullDownMenu.h>
#include <PopUpMenu.h>
#include <CheckBox.h>
#include <RadioBox.h>

/*
 Separator is used as a visual aid to separate adjacent objects in a display for purely
 aesthetic reasons.
 Separator appears as a line between the objects it is separating.
 It can be oriented vertically or horizontally.
 For example, separators can be used in menus to separate menu items.
*/

class PSeparator;

active class Separator : public GWidget {

public:

// parameters can be
// margin : Distance between the beginning of the separator and the left/right margin.
// type : specifies the type of the Separator like SHADOW_ETCHED_IN, SINGLE_LINE, ...

  Separator(GWindow &W, int margin=0, 
	    GUISeparatorType::Value type=GUISeparatorType::SHADOW_ETCHED_IN,
	    GUIOrientation::Value orientation=GUIOrientation::HORIZONTAL,
	    const char* name="Separator", 
	    ArgList userOptions=0, Cardinal nUserOptions=0);

  Separator(PullDownMenu &M, int margin=0, 
	    GUISeparatorType::Value type=GUISeparatorType::SHADOW_ETCHED_IN,
	    GUIOrientation::Value orientation=GUIOrientation::HORIZONTAL,
	    const char* name="Saparator", 
	    ArgList userOptions=0, Cardinal nUserOptions=0);

  Separator(PopUpMenu &M, int margin=0, 
	    GUISeparatorType::Value type=GUISeparatorType::SHADOW_ETCHED_IN,
	    GUIOrientation::Value orientation=GUIOrientation::HORIZONTAL,
	    const char* name="Saparator", 
	    ArgList userOptions=0, Cardinal nUserOptions=0);

  // Motif resources :
  void Resources(int margin=-1,
		 GUIOrientation::Value orientation=GUIOrientation::DEFAULT,
		 GUISeparatorType::Value separatorType=
		 GUISeparatorType::DEFAULT);

  PSeparator *Passive();

  ~Separator();

  private :

  PSeparator *impl;
};

#endif /* _SCPP_Separator_h */






