// -*- mode: c++ ; outline-regexp:"[ 	/]*--------------------" -*-
// $Id: $
// 
// Contens:	SimpleButtonContainer.h
//
//		
//		
//
// Author :	Walter Pineda
//              EPFL DI-LTI     pineda@di.epfl.ch
//              1015 Ecublens   + 41 21 693 4652
//              Switzerland     + 41 21 693 6600 (Fax)
//
// Creation : Tue May  9 1995
//
// $Author: $
// $Date:  $
// $Revision: $
// $State: $
// $Header:  $
// $Locker:  $
// $Log: $

#ifndef _SCPP_SimpleButtonContainer_h
#define _SCPP_SimpleButtonContainer_h


#include <scxx.h>
#include <EHSimpleButtonContainer.h>
#include <GWidget.h>

class PSimpleButtonContainer;

/*
 SimpleButtonContainer is intended to be the base class for all containers
 containing MenuButtons and ToggleButtons.
 Each button must have a code unique in a particular container.
*/

active class SimpleButtonContainer : public GWidget, 
                                     public SimpleButtonContainerEventHandler {

public:

  // 'sensitive' parameter can be set in order to disable any further
  // reception of events on the SimpleButtonContainer
  SimpleButtonContainer(Boolean sequential=False, int debug=0);

  // Accepted when a button has been pressed.
  // Return the integer code of the button pressed in this SimpleButtonContainer.
  int ItemSelected(Boolean sensitive=GUIBool::SENSITIVE, 
		   Boolean reset=GUIBool::NO_RESET);
  
  // return the integer code of button activated in this SimpleButtonContainer.
  // -1 is returned when no item has been selected.
  int GetSelectedItem();

  ~SimpleButtonContainer();

  void ItemSelectedEvent(); // private callback entry.

  PSimpleButtonContainer *Passive();

  void InitImplementation(PSimpleButtonContainer *implm);

  private :

  @SimpleButtonContainer();

  PSimpleButtonContainer *impl;

  // don't use : intended to bypass gnus compiler bug.
  SimpleButtonContainer(SimpleButtonContainer &dummy);
};

#endif /* _SCPP_SimpleButtonContainer_h */
